/*
Copyright 1990-2001 Sun Microsystems, Inc. All Rights Reserved.

Permission is hereby granted, free of charge, to any person obtaining a
copy of this software and associated documentation files (the
"Software"), to deal in the Software without restriction, including
without limitation the rights to use, copy, modify, merge, publish,
distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to
the following conditions: The above copyright notice and this
permission notice shall be included in all copies or substantial
portions of the Software.


THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
IN NO EVENT SHALL THE OPEN GROUP OR SUN MICROSYSTEMS, INC. BE LIABLE
FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH
THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE EVEN IF
ADVISED IN ADVANCE OF THE POSSIBILITY OF SUCH DAMAGES.


Except as contained in this notice, the names of The Open Group and/or
Sun Microsystems, Inc. shall not be used in advertising or otherwise to
promote the sale, use or other dealings in this Software without prior
written authorization from The Open Group and/or Sun Microsystems,
Inc., as applicable.


X Window System is a trademark of The Open Group

OSF/1, OSF/Motif and Motif are registered trademarks, and OSF, the OSF
logo, LBX, X Window System, and Xinerama are trademarks of the Open
Group. All other trademarks and registered trademarks mentioned herein
are the property of their respective owners. No right, title or
interest in or to any trademark, service mark, logo or trade name of
Sun Microsystems, Inc. or its licensors is granted.

*/

#ifndef VM_Separator_Public_hh
#define VM_Separator_Public_hh

#include <IMProtocolStruct.h>

#define STATUS_BUF_LEN 256
#define PREEDIT_BUF_LEN 800
#define LOOKUP_BUF_LEN 1200
#define COMMIT_BUF_LEN 512
#define COMMAND_BUF_LEN 1024

#define ADP_REQ_LEN COMMAND_BUF_LEN
#define ADP_REP_LEN (1024*10)

#define MAX_STATUS_LEN 256
#define MAX_LOOKUP_NUM 36
#define MAX_LOOKUP_LEN 100

#define CONNECT_START   100
#define CONNECT_END     101

#ifdef	USE_DOOR
#define DOOR_TMP_FILE	"/tmp/.htt_server_door"
#endif

#ifdef	notdef
typedef struct _shared_session_data {
  int  driver_id;
  char if_name[40];
  char if_version[40];
  char locale[20];
  int  session_id;
  int  public_status;
  int  private_status;
} VMSharedSessionData;
#endif

typedef struct _Session_Private {
  char *locale;
  char *name;
  int driver_id;
  int session_id;
#ifdef	notdef
  long session_address;
#endif
  IMEncoding encoding;
  char trigger_on;
  char status_start;
} VMSessionPrivate;

typedef unsigned char * VMSharedArgumentsArea;

typedef struct _signal_data {
  int type;
  int session_id;
#ifdef	nodef
  long session_address;
  void * sh_session_addr;
#endif
  void * sh_request_args_addr;
  void * sh_reply_args_addr;
}VMSignalData;

#endif
