/*
Copyright 1990-2001 Sun Microsystems, Inc. All Rights Reserved.

Permission is hereby granted, free of charge, to any person obtaining a
copy of this software and associated documentation files (the
"Software"), to deal in the Software without restriction, including
without limitation the rights to use, copy, modify, merge, publish,
distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to
the following conditions: The above copyright notice and this
permission notice shall be included in all copies or substantial
portions of the Software.


THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
IN NO EVENT SHALL THE OPEN GROUP OR SUN MICROSYSTEMS, INC. BE LIABLE
FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH
THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE EVEN IF
ADVISED IN ADVANCE OF THE POSSIBILITY OF SUCH DAMAGES.


Except as contained in this notice, the names of The Open Group and/or
Sun Microsystems, Inc. shall not be used in advertising or otherwise to
promote the sale, use or other dealings in this Software without prior
written authorization from The Open Group and/or Sun Microsystems,
Inc., as applicable.


X Window System is a trademark of The Open Group

OSF/1, OSF/Motif and Motif are registered trademarks, and OSF, the OSF
logo, LBX, X Window System, and Xinerama are trademarks of the Open
Group. All other trademarks and registered trademarks mentioned herein
are the property of their respective owners. No right, title or
interest in or to any trademark, service mark, logo or trade name of
Sun Microsystems, Inc. or its licensors is granted.

*/
#ifndef XSunIM_Adaptor_HotKey_hh
#define XSunIM_Adaptor_HotKey_hh

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/keysym.h>
#include <X11/keysymdef.h>
#include <X11/Sunkeysym.h>

typedef enum {
    SystemLevel = 1,
    UserLevel   = 2
} LevelTag;

typedef struct _HotKeyNode {
    unsigned long keysym;
    unsigned int modifier_mask;
    unsigned int modifier;
    char * locale;
    char * if_name;
    char * methods_name;
    LevelTag    tag;
    struct _HotKeyNode * next;
} HotKeyNode;

class HotKey {
public:
/*
	static void buildHotKeyTable();
*/
	static void buildHotKeyTable(char *);
	static void buildSystemHotKeyTable(char *);
	static void buildUserHotKeyTable(char *);
	static char * getLanguageEngineFromHotKey(XKeyEvent *, LevelTag *);
	static char * getMethodsName(char*, char *);
	static unsigned long getHotKeyKeysym(char*, char*);
	static unsigned int getHotKeyModifier(char*, char*);
	static LevelTag getHotKeyLevel(char*, char*); 
	static HotKeyNode * createNewNode(char*, char *, char *, char *, LevelTag);
	static void addHotKeyTable(char*, char *, char *, char*, LevelTag);
	static Bool isRegisteredKey(HotKeyNode *, XKeyEvent *, LevelTag *);
	static void add_keylist(char*, char *, char *, char *, LevelTag );
	static void deleteHotKeyTable(void);

private:
};

#endif
