#ifndef lint
#ident	"@(#)XSunIMTrans.h	2.5	94/08/08 SMI"
#endif

/******************************************************************

              Copyright 1990, 1991, by Sun Microsystems, Inc.

Permission to use, copy, modify, distribute, and sell this software
and its documentation for any purpose is hereby granted without fee,
provided that the above copyright notice appear in all copies and
that both that copyright notice and this permission notice appear
in supporting documentation, and that the name of Sun Microsystems, Inc.
not be used in advertising or publicity pertaining to distribution
of the software without specific, written prior permission.
Sun Microsystems, Inc. makes no representations about the suitability of
this software for any purpose.  It is provided "as is" without
express or implied warranty.

Sun Microsystems Inc. DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS
SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS,
IN NO EVENT SHALL Sun Microsystems, Inc. BE LIABLE FOR ANY SPECIAL, INDIRECT
OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS
OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE
OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE
OR PERFORMANCE OF THIS SOFTWARE.

                                             Sun Microsystems, Inc.
******************************************************************/

#ifndef _XSunTrans_DEFINED
#define _XSunTrans_DEFINED

/*
 * Translation manager
 */

#ifndef Const
#ifdef __STDC__
#define Const const
#else
#define Const /**/
#endif
#endif

typedef void (*IMActionProc)(
#if NeedFunctionPrototypes
#ifndef STANDALONE
    iml_session_t*	/* s */,
#endif /* STANDALONE */
    XEvent*		/* event */,
    char**		/* params */,
    int*		/* num_params */,
    XPointer		/* call_data */
#endif
);

typedef struct _IMActionsRec {
    char	 *string;
    IMActionProc proc;
} IMActionsRec, *IMActionsList;

typedef struct _IMActionRec {
    IMActionProc proc;
    Const char	 *proc_name;
    char	 **params;
    unsigned int num_params;
} IMActionRec, *IMActionList;

#define IMBindSucceeded		0
#define IMBindFailed		1
#define IMBindNeedMoreEvent	2

typedef enum {
    IMBindResultSucceeded = 10,
    IMBindResultFailed    = 11
} IMBindResultType;

typedef struct _IMBindResultRec *IMBindResult;
typedef struct _IMBindResultRec {
    IMBindResultType	result;
    int			num_events;
    Bool		*is_used_event;
    XEvent		*events;
    int			num_actions;
    IMActionList	actions;
    IMBindResult	next;
} IMBindResultRec;

#endif _XSunTrans_DEFINED
