/*
Copyright 1990-2001 Sun Microsystems, Inc. All Rights Reserved.

Permission is hereby granted, free of charge, to any person obtaining a
copy of this software and associated documentation files (the
"Software"), to deal in the Software without restriction, including
without limitation the rights to use, copy, modify, merge, publish,
distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to
the following conditions: The above copyright notice and this
permission notice shall be included in all copies or substantial
portions of the Software.


THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
IN NO EVENT SHALL THE OPEN GROUP OR SUN MICROSYSTEMS, INC. BE LIABLE
FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH
THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE EVEN IF
ADVISED IN ADVANCE OF THE POSSIBILITY OF SUCH DAMAGES.


Except as contained in this notice, the names of The Open Group and/or
Sun Microsystems, Inc. shall not be used in advertising or otherwise to
promote the sale, use or other dealings in this Software without prior
written authorization from The Open Group and/or Sun Microsystems,
Inc., as applicable.


X Window System is a trademark of The Open Group

OSF/1, OSF/Motif and Motif are registered trademarks, and OSF, the OSF
logo, LBX, X Window System, and Xinerama are trademarks of the Open
Group. All other trademarks and registered trademarks mentioned herein
are the property of their respective owners. No right, title or
interest in or to any trademark, service mark, logo or trade name of
Sun Microsystems, Inc. or its licensors is granted.

*/
#ifndef IMUSer_hh
#define IMUser_hh

#include "CompoundString.hh"
#include "IMList.hh"
#include "itt.hh"
#include "resource.hh"

class SunIMSession;

class IMUser {
 public :
  IMUser(Itt * arg_itt);		// ctor
  IMUser(char *arg_user, char *arg_host, char *arg_disp, char *arg_auth);
  ~IMUser();		// dtor
  static void destroy();
  static IMUser* getIMUser(int id);
  static IMUser* getIMUser(char *arg_user, char *arg_host, char *arg_disp,
							char *arg_auth);
  static IMUser* getIMUser(CompoundString *cs);
  int getResourceValues(int, ...);
  int setResourceValues(int, ...);
  int updateResource(char *resourcestring);
  int getId() const;
  char *getUserName() const;
  char *getHostName() const;
  char *getDisplayId() const;
  char *getAuthPasswd() const;

  void setProxySession(SunIMSession *aSession) {
    aux_proxy_session = aSession;
  }
  SunIMSession *getProxySession() {return aux_proxy_session;}
 private :
  void countVaList(va_list var, int *total_count);
  void vaToNestedList(va_list var, int max_count,
				IttResourceArg **args_return);
  IMResource  *resource;
  static IMResource  *root_resource;
  static Itt		*itt;		
  IMList<SvrIc> ic_list; 
  int	this_id;
  static int s_id;
  CompoundString *user_info;
  char *username;
  char *hostname;
  char *displayid;
  char *authpasswd;

  SunIMSession *aux_proxy_session;
}; 

#endif   // IMUser_hh
  
